
; CC5X Version 3.1I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   3. Dec 2008   8:42  *************

	processor  16F88
	radix  DEC

INDF        EQU   0x00
PCL         EQU   0x02
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
GIE         EQU   7
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
OSCCON      EQU   0x8F
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ANSEL       EQU   0x9B
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
PEIE        EQU   6
TXIF        EQU   4
RCIF        EQU   5
CREN        EQU   4
SPEN        EQU   7
TXIE        EQU   4
RCIE        EQU   5
BRGH        EQU   2
SYNC        EQU   4
TXEN        EQU   5
RD          EQU   0
EEPGD       EQU   7
x           EQU   0x7F
x_2         EQU   0x26
y           EQU   0x28
z           EQU   0x29
x_3         EQU   0x7F
y_2         EQU   0x7F
want_ints   EQU   0
want_ints_2 EQU   0
nate        EQU   0x3B
counter     EQU   0x7F
x_4         EQU   0x3B
nate_2      EQU   0x2B
my_byte     EQU   0x2C
i           EQU   0x2E
k           EQU   0x2F
m           EQU   0x30
temp        EQU   0x31
high_byte   EQU   0x32
low_byte    EQU   0x33
C1cnt       EQU   0x3B
C2tmp       EQU   0x3C
C3cnt       EQU   0x3B
C4tmp       EQU   0x3C
C5cnt       EQU   0x3B
C6tmp       EQU   0x3C
C7rem       EQU   0x3E
in_byte     EQU   0x22
choice_2    EQU   0x23
temp_data   EQU   0x26
pressure_data_high EQU   0x28
pressure_data_low EQU   0x29
register_name EQU   0x2B
in_byte_2   EQU   0x2C
register_name_2 EQU   0x2B
in_byte_3   EQU   0x2C
register_name_3 EQU   0x2B
register_value EQU   0x2C
in_byte_4   EQU   0x2D
outgoing_byte EQU   0x2E
incoming_byte EQU   0x2F
x_5         EQU   0x30
ci          EQU   0x3B

	GOTO main

  ; FILE C:\Global\Code\16F88\SCP1000\SCP1000-Testing.c
			;/*
			;    10-15-06
			;    Nathan Seidle
			;    nathan@sparkfun.com
			;    Copyright Spark Fun Electronics 2006
			;    
			;    Software SPI control
			;    PIC 16F88
			;    
			;    Reading and writing to SCP1000-D01 Barometric pressure sensor
			;    
			;    This is a very precise (19-bit!!), configurable pressure sensor
			;    
			;    Be sure to read and re-read the datasheet. Once it's fully absorbed,
			;    the interface is pretty straight forward.
			;    
			;    Choose your processor and compiler well. This sensor uses 16 and 19-bit decimals
			;    It is tricky to get the data into a contained, printable value on an 8-bit PIC.
			;    We decided to print hex values for the pressure data and then convert
			;    hex to decimal on the computer using window's calculator.
			;    
			;*/
			;#define Clock_8MHz
			;#define Baud_9600
			;
			;#include "c:\Global\Code\C\16F88.h"  // device dependent interrupt definitions
			;
			;#pragma origin 4
	ORG 0x0004

  ; FILE c:\Global\Code\Pics\Code\Delay.c
			;/*
			;    7/23/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Delays for... Well, everything.
			;    
			;    11-11 Updated the delays - now they actually delay what they say they should.
			;    
			;    10-11-03 Updated delays. New CC5X compiler is muy optimized.
			;
			;*/
			;
			;//Really short delay
			;void delay_us(uns16 x)
			;{
_const1
	MOVWF ci
	MOVLW .0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW .127
	ADDLW .35
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSC 0x03,Carry
	INCF  EEADRH,1
	BSF   0x03,RP0
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m001
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	BCF   0x03,RP1
	RETURN
m001	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	BCF   0x03,RP1
	RETURN
	DW    0x32D4
	DW    0x386D
	DW    0x12BD
	DW    0x1064
	DW    0x2800
	DW    0x32F2
	DW    0x39F3
	DW    0x3975
	DW    0x2DE5
	DW    0x30D0
	DW    0x1EDD
	DW    0x3425
	DW    0x2D
	DW    0x39E1
	DW    0x31E9
	DW    0x395F
	DW    0x3B65
	DW    0x12BD
	DW    0x1068
	DW    0x2980
	DW    0x20D4
	DW    0x2AD4
	DW    0x1ED3
	DW    0x3125
	DW    0xA
delay_us
			;
			;#ifdef Clock_4MHz
			;    //Calling with 10us returns 69us
			;    for ( ; x > 0 ; x--);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Calling with 1us returns 11us
			;    //Calling with 10us returns 56us
			;    //for ( ; x > 0 ; x--);
			;    
			;    //Calling with 1us returns 7.5us
			;    //Calling with 10us returns 48
			;    //Calling with 1000us returns 4.5ms
			;    while(--x); 
m002	DECF  x,1
	INCF  x,W
	BTFSC 0x03,Zero_
	DECF  x+1,1
	MOVF  x,W
	IORWF x+1,W
	BTFSS 0x03,Zero_
	GOTO  m002
			;
			;    //while(x--); 
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    while(--x); 
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_us(1) = 6.4us
			;    //delay_us(10) = 16.8us
			;    //delay_us(100) = 110.4us
			;    while(x > 4) x -= 5;
			;#endif
			;
			;#ifdef Clock_20MHz
			;    //Calling with 10us returns 13 us
			;    //Calling with 1us returns 1.8us
			;    while(--x) nop(); 
			;#endif
			;
			;}
	RETURN
			;
			;//General short delay
			;void delay_ms(uns16 x)
			;{
delay_ms
			;
			;#ifdef Clock_4MHz
			;    //Clocks out at 1002us per 1ms
			;    int y;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 108 ; y++);
			;#endif
			;
			;#ifdef Clock_8MHz
			;    //Clocks out at 1006us per 1ms
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
m003	MOVF  x_2,W
	IORWF x_2+1,W
	BTFSC 0x03,Zero_
	GOTO  m008
			;        for ( y = 0 ; y < 4 ; y++)
	CLRF  y
m004	MOVLW .4
	SUBWF y,W
	BTFSC 0x03,Carry
	GOTO  m007
			;            for ( z = 0 ; z < 69 ; z++);
	CLRF  z
m005	MOVLW .69
	SUBWF z,W
	BTFSC 0x03,Carry
	GOTO  m006
	INCF  z,1
	GOTO  m005
m006	INCF  y,1
	GOTO  m004
m007	DECF  x_2,1
	INCF  x_2,W
	BTFSC 0x03,Zero_
	DECF  x_2+1,1
	GOTO  m003
			;#endif
			;
			;#ifdef Clock_9216MHz
			;    //Copied from 8MHz - not tested
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 69 ; z++);
			;#endif
			;
			;#ifdef Clock_10MHz
			;    //delay_ms(1) = 1.006ms
			;    //delay_ms(10) = 10.02ms
			;    //delay_ms(100) = 100.16ms
			;
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 87 ; z++);
			;#endif
			;
			;#ifdef Clock_20MHz
			;
			;    uns8 y, z;
			;    //Clocks out to 1.00ms per 1ms
			;    //9.99 ms per 10ms
			;    for ( ; x > 0 ; x--)
			;        for ( y = 0 ; y < 4 ; y++)
			;            for ( z = 0 ; z < 176 ; z++);
			;#endif
			;
			;}
m008	RETURN
			;
			;//Delays in 31.25kHz Low Power mode using the internal 31.25kHz oscillator
			;void delay_s_lp(uns16 x)
			;{
delay_s_lp
			;
			;    uns16 y;
			;    //Clocks out to 1.001s per 1s
			;    for ( ; x > 0 ; x--)
m009	MOVF  x_3,W
	IORWF x_3+1,W
	BTFSC 0x03,Zero_
	GOTO  m013
			;        for ( y = 0 ; y < 775 ; y++);
	CLRF  y_2
	CLRF  y_2+1
m010	MOVLW .3
	SUBWF y_2+1,W
	BTFSS 0x03,Carry
	GOTO  m011
	BTFSS 0x03,Zero_
	GOTO  m012
	MOVLW .7
	SUBWF y_2,W
	BTFSC 0x03,Carry
	GOTO  m012
m011	INCF  y_2,1
	BTFSC 0x03,Zero_
	INCF  y_2+1,1
	GOTO  m010
m012	DECF  x_3,1
	INCF  x_3,W
	BTFSC 0x03,Zero_
	DECF  x_3+1,1
	GOTO  m009

  ; FILE C:\Global\Code\16F88\SCP1000\SCP1000-Testing.c
			;
			;#include "c:\Global\Code\Pics\Code\Delay.c"   //Standard delays
m013	RETURN

  ; FILE c:\Global\Code\Pics\Code\stdio.c
			;/*
			;    5/21/02
			;    Nathan Seidle
			;    nathan.seidle@colorado.edu
			;    
			;    Serial Out Started on 5-21
			;    rs_out Perfected on 5-24
			;    
			;    1Wire Serial Comm works with 4MHz Xtal
			;    Connect Serial_Out to Pin2 on DB9 Serial Connector
			;    Connect Pin5 on DB9 Connector to Signal Ground
			;    9600 Baud 8-N-1
			;    
			;    5-21 My first real C and Pic program.
			;    5-24 Attempting 20MHz implementation
			;    5-25 20MHz works
			;    5-25 Serial In works at 4MHz
			;    5-25 Passing Strings 9:20
			;    5-25 Option Selection 9:45
			;
			;    6-9  'Stdio.c' created. Printf working with %d and %h
			;    7-20 Added a longer delay after rs_out
			;         Trying to get 20MHz on the 16F873 - I think the XTal is bad.
			;         20MHz also needs 5V Vdd. Something I dont have.
			;    2-9-03 Overhauled the 4MHz timing. Serial out works very well now.
			;    
			;    6-16-03 Discovered how to pass string in cc5x
			;        void test(const char *str);
			;        test("zbcdefghij"); TXREG = str[1];
			;        
			;        Moved to hardware UART. Old STDIO will be in goodworks.
			;        
			;        Works great! Even got the special print characters (\n, \r, \0) to work.
			;    
			;    4-25-04 Added new %d routine to print 16 bit signed decimal numbers without leading 0s.
			;        
			;
			;*/
			;
			;//Setup the hardware UART TX module
			;void enable_uart_TX(bit want_ints)
			;{
enable_uart_TX
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 7; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints
	GOTO  m014
			;    {
			;        TXIE = 1;
	BSF   0x8C,TXIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;    TXEN = 1; //Enable transmission
m014	BSF   0x98,TXEN
			;}    
	RETURN
			;
			;//Setup the hardware UART RX module
			;void enable_uart_RX(bit want_ints)
			;{
enable_uart_RX
			;
			;    BRGH = 0; //Normal speed UART
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x98,BRGH
			;
			;    SYNC = 0;
	BCF   0x98,SYNC
			;    SPEN = 1;
	BCF   0x03,RP0
	BSF   0x18,SPEN
			;
			;#ifdef Clock_4MHz
			;    #ifdef Baud_9600
			;    SPBRG = 6; //4MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_8MHz
			;    #ifdef Baud_4800
			;    SPBRG = 25; //8MHz for 4800 Baud
			;    #endif
			;    #ifdef Baud_9600
			;    SPBRG = 12; //8MHz for 9600 Baud
	MOVLW .12
	BSF   0x03,RP0
	MOVWF SPBRG
			;    #endif
			;    #ifdef Baud_57600
			;    BRGH = 1; //High speed UART
			;    SPBRG = 8; //8MHz for 57600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Crazy_Osc
			;    #ifdef Baud_9600
			;    SPBRG = 32; //20MHz for 9600 Baud
			;    #endif
			;#endif
			;
			;#ifdef Clock_20MHz
			;    #ifdef Baud_9600
			;    SPBRG = 31; //20MHz for 9600 Baud
			;    #endif
			;
			;    #ifdef Baud_4800
			;    SPBRG = 64; //20MHz for 4800 Baud
			;    #endif
			;#endif
			;
			;    CREN = 1;
	BCF   0x03,RP0
	BSF   0x18,CREN
			;
			;    //WREN = 1;
			;
			;    if(want_ints) //Check if we want to turn on interrupts
	BTFSS 0x7F,want_ints_2
	GOTO  m015
			;    {
			;        RCIE = 1;
	BSF   0x03,RP0
	BSF   0x8C,RCIE
			;        PEIE = 1;
	BSF   0x0B,PEIE
			;        GIE = 1;
	BSF   0x0B,GIE
			;    }
			;
			;}    
m015	BSF   0x03,RP0
	RETURN
			;
			;//Sends nate to the Transmit Register
			;void putc(uns8 nate)
			;{
putc
	MOVWF nate
			;    while(TXIF == 0);
m016	BTFSS 0x0C,TXIF
	GOTO  m016
			;    TXREG = nate;
	MOVF  nate,W
	MOVWF TXREG
			;}
	RETURN
			;
			;uns8 getc(void)
			;{
getc
			;    while(RCIF == 0);
	BCF   0x03,RP0
	BCF   0x03,RP1
m017	BTFSS 0x0C,RCIF
	GOTO  m017
			;    return (RCREG);
	MOVF  RCREG,W
	RETURN
			;}    
			;
			;uns8 scanc(void)
			;{
scanc
			;    uns16 counter = 0;
	CLRF  counter
	CLRF  counter+1
			;    
			;    //CREN = 0;
			;    //CREN = 1;
			;    
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;    while(RCIF == 0)
m018	BTFSC 0x0C,RCIF
	GOTO  m019
			;    {
			;        counter++;
	INCF  counter,1
	BTFSC 0x03,Zero_
	INCF  counter+1,1
			;        if(counter == 1000) return 0;
	MOVF  counter,W
	XORLW .232
	BTFSS 0x03,Zero_
	GOTO  m018
	MOVF  counter+1,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m018
	RETLW .0
			;    }
			;    
			;    return (RCREG);
m019	MOVF  RCREG,W
	RETURN
			;}    
			;
			;//Returns ASCII Decimal and Hex values
			;uns8 bin2Hex(char x)
			;{
bin2Hex
	MOVWF x_4
			;   skip(x);
	CLRF  PCLATH
	MOVF  x_4,W
	ADDWF PCL,1
			;   #pragma return[16] = "0123456789ABCDEF"
	RETLW .48
	RETLW .49
	RETLW .50
	RETLW .51
	RETLW .52
	RETLW .53
	RETLW .54
	RETLW .55
	RETLW .56
	RETLW .57
	RETLW .65
	RETLW .66
	RETLW .67
	RETLW .68
	RETLW .69
	RETLW .70
			;}
			;
			;//Prints a string including variables
			;void printf(const char *nate, int16 my_byte)
			;{
printf
			;  
			;    uns8 i, k, m, temp;
			;    uns8 high_byte = 0, low_byte = 0;
	CLRF  high_byte
	CLRF  low_byte
			;    uns8 y, z;
			;    
			;    uns8 decimal_output[5];
			;    
			;    for(i = 0 ; ; i++)
	CLRF  i
			;    {
			;        //delay_ms(3);
			;        
			;        k = nate[i];
m020	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;        if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;            break;
	GOTO  m046
			;
			;        else if (k == '%') //Print var
	XORLW .37
	BTFSS 0x03,Zero_
	GOTO  m044
			;        {
			;            i++;
	INCF  i,1
			;            k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;            if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;                break;
	GOTO  m046
			;            else if (k == '\\') //Print special characters
	XORLW .92
	BTFSS 0x03,Zero_
	GOTO  m021
			;            {
			;                i++;
	INCF  i,1
			;                k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;                
			;                putc(k);
	CALL  putc
			;                
			;
			;            } //End Special Characters
			;            else if (k == 'b') //Print Binary
	GOTO  m045
m021	MOVF  k,W
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m026
			;            {
			;                for( m = 0 ; m < 8 ; m++ )
	CLRF  m
m022	MOVLW .8
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m045
			;                {
			;                    if (my_byte.7 == 1) putc('1');
	BTFSS my_byte,7
	GOTO  m023
	MOVLW .49
	CALL  putc
			;                    if (my_byte.7 == 0) putc('0');
m023	BTFSC my_byte,7
	GOTO  m024
	MOVLW .48
	CALL  putc
			;                    if (m == 3) putc(' ');
m024	MOVF  m,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m025
	MOVLW .32
	CALL  putc
			;                    
			;                    my_byte = my_byte << 1;
m025	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
			;                }
	INCF  m,1
	GOTO  m022
			;            } //End Binary               
			;            else if (k == 'd') //Print Decimal
m026	MOVF  k,W
	XORLW .100
	BTFSS 0x03,Zero_
	GOTO  m040
			;            {
			;                //Print negative sign and take 2's compliment
			;                
			;                if(my_byte < 0)
	BTFSS my_byte+1,7
	GOTO  m029
			;                {
			;                    putc('-');
	MOVLW .45
	CALL  putc
			;                    my_byte *= -1;
	MOVF  my_byte,W
	MOVWF C2tmp
	MOVF  my_byte+1,W
	MOVWF C2tmp+1
	MOVLW .16
	MOVWF C1cnt
m027	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
	RLF   C2tmp,1
	RLF   C2tmp+1,1
	BTFSS 0x03,Carry
	GOTO  m028
	DECF  my_byte+1,1
	DECF  my_byte,1
	INCFSZ my_byte,W
	INCF  my_byte+1,1
m028	DECFSZ C1cnt,1
	GOTO  m027
			;                }
			;                
			;                
			;                if (my_byte == 0)
m029	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSS 0x03,Zero_
	GOTO  m030
			;                    putc('0');
	MOVLW .48
	CALL  putc
			;                else
	GOTO  m045
			;                {
			;                    //Divide number by a series of 10s
			;                    for(m = 4 ; my_byte > 0 ; m--)
m030	MOVLW .4
	MOVWF m
m031	BTFSC my_byte+1,7
	GOTO  m038
	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSC 0x03,Zero_
	GOTO  m038
			;                    {
			;                        temp = my_byte % (uns16)10;
	MOVF  my_byte,W
	MOVWF C4tmp
	MOVF  my_byte+1,W
	MOVWF C4tmp+1
	CLRF  temp
	MOVLW .16
	MOVWF C3cnt
m032	RLF   C4tmp,1
	RLF   C4tmp+1,1
	RLF   temp,1
	BTFSC 0x03,Carry
	GOTO  m033
	MOVLW .10
	SUBWF temp,W
	BTFSS 0x03,Carry
	GOTO  m034
m033	MOVLW .10
	SUBWF temp,1
m034	DECFSZ C3cnt,1
	GOTO  m032
			;                        decimal_output[m] = temp;
	MOVLW .54
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  temp,W
	MOVWF INDF
			;                        my_byte = my_byte / (uns16)10;               
	MOVF  my_byte,W
	MOVWF C6tmp
	MOVF  my_byte+1,W
	MOVWF C6tmp+1
	CLRF  C7rem
	MOVLW .16
	MOVWF C5cnt
m035	RLF   C6tmp,1
	RLF   C6tmp+1,1
	RLF   C7rem,1
	BTFSC 0x03,Carry
	GOTO  m036
	MOVLW .10
	SUBWF C7rem,W
	BTFSS 0x03,Carry
	GOTO  m037
m036	MOVLW .10
	SUBWF C7rem,1
	BSF   0x03,Carry
m037	RLF   my_byte,1
	RLF   my_byte+1,1
	DECFSZ C5cnt,1
	GOTO  m035
			;                    }
	DECF  m,1
	GOTO  m031
			;                
			;                    for(m++ ; m < 5 ; m++)
m038	INCF  m,1
m039	MOVLW .5
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m045
			;                        putc(bin2Hex(decimal_output[m]));
	MOVLW .54
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  bin2Hex
	CALL  putc
	INCF  m,1
	GOTO  m039
			;                }
			;    
			;            } //End Decimal
			;            else if (k == 'h') //Print Hex
m040	MOVF  k,W
	XORLW .104
	BTFSS 0x03,Zero_
	GOTO  m042
			;            {
			;                //New trick 3-15-04
			;                putc('0');
	MOVLW .48
	CALL  putc
			;                putc('x');
	MOVLW .120
	CALL  putc
			;                
			;                if(my_byte > 0x00FF)
	BTFSC my_byte+1,7
	GOTO  m041
	MOVF  my_byte+1,1
	BTFSC 0x03,Zero_
	GOTO  m041
			;                {
			;                    putc(bin2Hex(my_byte.high8 >> 4));
	SWAPF my_byte+1,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                    putc(bin2Hex(my_byte.high8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte+1,W
	CALL  bin2Hex
	CALL  putc
			;                }
			;
			;                putc(bin2Hex(my_byte.low8 >> 4));
m041	SWAPF my_byte,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                putc(bin2Hex(my_byte.low8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte,W
	CALL  bin2Hex
	CALL  putc
			;
			;                /*high_byte.3 = my_byte.7;
			;                high_byte.2 = my_byte.6;
			;                high_byte.1 = my_byte.5;
			;                high_byte.0 = my_byte.4;
			;            
			;                low_byte.3 = my_byte.3;
			;                low_byte.2 = my_byte.2;
			;                low_byte.1 = my_byte.1;
			;                low_byte.0 = my_byte.0;
			;        
			;                putc('0');
			;                putc('x');
			;            
			;                putc(bin2Hex(high_byte));
			;                putc(bin2Hex(low_byte));*/
			;            } //End Hex
			;            else if (k == 'f') //Print Float
	GOTO  m045
m042	MOVF  k,W
	XORLW .102
	BTFSS 0x03,Zero_
	GOTO  m043
			;            {
			;                putc('!');
	MOVLW .33
	CALL  putc
			;            } //End Float
			;            else if (k == 'u') //Print Direct Character
	GOTO  m045
m043	MOVF  k,W
	XORLW .117
	BTFSS 0x03,Zero_
	GOTO  m045
			;            {
			;                //All ascii characters below 20 are special and screwy characters
			;                //if(my_byte > 20) 
			;                    putc(my_byte);
	MOVF  my_byte,W
	CALL  putc
			;            } //End Direct
			;                        
			;        } //End Special Chars           
			;
			;        else
	GOTO  m045
			;            putc(k);
m044	MOVF  k,W
	CALL  putc
			;    }    
m045	INCF  i,1
	GOTO  m020
			;}
m046	RETURN

  ; FILE c:\Global\Code\C\math24f.h
			;// *************************************************
			;// 24 bit basic floating point math operations
			;// Copyright (c) B Knudsen Data, Norway, 2000 - 2001
			;// *************************************************
			;
			;#pragma library 1
			;/* PROTOTYPES for page definition in application header file:
			;float24 operator* _fmul24( float24 arg1f24, float24 arg2f24);
			;float24 operator/ _fdiv24( float24 arg1f24, float24 arg2f24);
			;float24 operator+ _fadd24( float24 arg1f24, float24 arg2f24);
			;float24 operator- _fsub24( float24 arg1f24, float24 arg2f24);
			;float24 operator= _int24ToFloat24( int24 arg1f24);
			;float24 operator= _int32ToFloat24( int32 arg32);
			;int24 operator= _float24ToInt24( float24 arg1f24);
			;bit operator< _f24_LT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator>= _f24_GE_f24( float24 arg1f24, float24 arg2f24);
			;bit operator> _f24_GT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator<= _f24_LE_f24( float24 arg1f24, float24 arg2f24);
			;*/
			;
			;// DEFINABLE SYMBOLS (in the application code):
			;//#define FP_OPTIM_SPEED  // optimize for SPEED: default
			;//#define FP_OPTIM_SIZE   // optimize for SIZE
			;//#define DISABLE_ROUNDING   // disable rounding and save code space
			;
			;#define float24ToIEEE754(a) { a.mid8=rl(a.mid8); a.high8=rr(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;#define IEEE754ToFloat24(a) { a.mid8=rl(a.mid8); a.high8=rl(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;
			;
			;/*  24 bit floating point format:
			;
			;  address  ID
			;    X      a.low8  : LSB, bit 0-7 of mantissa
			;    X+1    a.mid8  : bit 8-14 of mantissa, bit 15 is the sign bit
			;    X+2    a.high8 : MSB, bit 0-7 of exponent, with bias 0x7F
			;
			;    bit 15 of mantissa is a hidden bit, always equal to 1
			;    zero (0.0) :  a.high8 = 0 (mantissa & sign ignored)
			;
			;   MSB    LSB
			;    7F 00 00  : 1.0   =  1.0  * 2**(0x7F-0x7F) = 1.0 * 1
			;    7F 80 00  : -1.0  = -1.0  * 2**(0x7F-0x7F) = -1.0 * 1
			;    80 00 00  : 2.0   =  1.0  * 2**(0x80-0x7F) = 1.0 * 2
			;    80 40 00  : 3.0   =  1.5  * 2**(0x80-0x7F) = 1.5 * 2
			;    7E 60 00  : 0.875 =  1.75 * 2**(0x7E-0x7F) = 1.75 * 0.5
			;    7F 60 00  : 1.75  =  1.75 * 2**(0x7E-0x7F) = 1.75 * 1
			;    7F 7F FF  : 1.999969482
			;    00 7C 5A  : 0.0 (mantissa & sign ignored)
			;    01 00 00  : 1.17549435e-38 =  1.0 * 2**(0x01-0x7F)
			;    FE 7F FF  : 3.40277175e+38 =  1.999969482 * 2**(0xFE-0x7F)
			;    FF 00 00  : +INF : positive infinity
			;    FF 80 00  : -INF : negative infinity
			;*/                 
			;
			;#define  FpBIAS  0x7F
			;
			;#ifndef FpFlags_defined
			; #define FpFlags_defined
			;
			; char FpFlags;
			; //bit IOV         @ FpFlags.0; // integer overflow flag: NOT USED
			; bit FpOverflow    @ FpFlags.1; // floating point overflow flag
			; bit FpUnderFlow   @ FpFlags.2; // floating point underflow flag
			; bit FpDiv0        @ FpFlags.3; // floating point divide by zero flag
			; //bit FpNAN       @ FpFlags.4; // not-a-number exception flag: NOT USED
			; bit FpDomainError @ FpFlags.5; // domain error exception flag
			; bit FpRounding    @ FpFlags.6; // floating point rounding flag, 0=truncation
			;                                // 1 = unbiased rounding to nearest LSB
			; //bit FpSaturate  @ FpFlags.7; // floating point saturate flag: NOT USED
			;
			; #pragma floatOverflow FpOverflow
			; #pragma floatUnderflow FpUnderFlow
			;
			; #define InitFpFlags()  FpFlags = 0x40 /* enable rounding as default */
			;#endif
			;
			;#ifdef DISABLE_ROUNDING
			; #pragma floatRounding 0
			;#endif
			;
			;
			;#if __CoreSet__ < 1600
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W;
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W;
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W;
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W;
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r);
			; #define genSub(r,a) W=a; r=subWFB(r);
			; #define genAddW(r,a) W=a; W=addWFC(r);
			; #define genSubW(r,a) W=a; W=subWFB(r);
			;#endif
			;
			;
			;
			;float24 operator* _fmul24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fmul24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
			;    aarg.high8 = W;
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
			;
			;    W = arg1f24.high8;
			;    if ( !Zero_)
			;        W = arg2f24.high8;
			;    if ( Zero_)
			;        goto RES0;
			;
			;    arg1f24.high8 += W /* arg2f24.high8 */;
			;    W = FpBIAS-1;
			;    if ( Carry)  {
			;        arg1f24.high8 -= W;
			;        if ( Carry)
			;            goto OVERFLOW;
			;    }
			;    else  {
			;        arg1f24.high8 -= W;
			;        if ( !Carry)
			;            goto UNDERFLOW;
			;    }
			;    aarg.low8 = arg1f24.low8;
			;
			;    aarg.15 = 1;
			;    arg2f24.15 = 1;
			;
			;    arg1f24.low16 = 0;
			;
			;    char counter = sizeof(aarg)*8;
			;
			;    do  {
			;        aarg = rr( aarg);
			;        if ( Carry)  {
			;            arg1f24.low8 += arg2f24.low8;
			;            genAdd( arg1f24.mid8, arg2f24.mid8);
			;        }
			;        arg1f24.low16 = rr( arg1f24.low16);
			;    } while ( -- counter > 0);
			;
			;    if ( !arg1f24.15)  {
			;        // catch Carry bit that was shifted out previously
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        if ( arg1f24.high8 == 0)
			;            goto UNDERFLOW;
			;        arg1f24.high8 -= 1;
			;        W = rl( aarg.high8);
			;        // restore bit behind LSB in Carry
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding  &&  Carry)  {
			;        arg1f24.low8 += 1;
			;        if ( !arg1f24.low8)  {
			;            arg1f24.mid8 += 1;
			;            if ( !arg1f24.mid8)  {
			;                // Carry = 1; //OK
			;                arg1f24.low16 = rr( arg1f24.low16);
			;                arg1f24.high8 += 1;
			;                if ( Zero_)
			;                    goto OVERFLOW;
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
			;  RES0:
			;    arg1f24.high8 = 0;
			;    goto MANTISSA;
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;    arg1f24.high8 = 0xFF;
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
			;
			;  SET_SIGN:
			;    if ( !(sign & 0x80))
			;        arg1f24.15 = 0;
			;    return arg1f24;
			;}
			;
			;
			;
			;float24 operator/ _fdiv24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fdiv24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
			;    aarg.high8 = W;
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
			;
			;    W = arg2f24.high8;
			;    if ( Zero_)
			;        goto Div0;
			;    if ( !arg1f24.high8)
			;        goto RES0;
			;
			;    arg1f24.high8 -= arg2f24.high8;
			;    W = FpBIAS;
			;    if ( !Carry)  {
			;        arg1f24.high8 += W;
			;        if ( !Carry)
			;            goto UNDERFLOW;
			;    }
			;    else  {
			;        arg1f24.high8 += W;
			;        if ( Carry)
			;            goto OVERFLOW;
			;    }
			;
			;    aarg.low8 = arg1f24.low8;
			;    aarg.15 = 1;
			;    arg2f24.15 = 1;
			;
			;    // division: shift & add
			;    char counter = 16;
			;    arg1f24.low16 = 0;  // speedup
			;
			;#if defined FP_OPTIM_SPEED || !defined FP_OPTIM_SIZE  // SPEED
			;
			;    goto START;
			;
			;  TEST_ZERO_L:
			;    W = aarg.low8 - arg2f24.low8;
			;    if (!Carry)
			;        goto SHIFT_IN_CARRY;
			;    aarg.low8 = W;
			;    aarg.high8 = 0;
			;    goto SET_AND_SHIFT_IN_CARRY;
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP:
			;        if (!Carry)  {
			;           START:
			;            W = aarg.high8 - arg2f24.mid8;
			;            if ( Zero_)
			;                goto TEST_ZERO_L;
			;            if ( !Carry)
			;                goto SHIFT_IN_CARRY;
			;        }
			;        aarg.low8 -= arg2f24.low8;
			;        genSub( aarg.high8, arg2f24.mid8);
			;      SET_AND_SHIFT_IN_CARRY:
			;        Carry = 1;
			;      SHIFT_IN_CARRY:
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        // Carry = 0;  // ok, speedup
			;        aarg = rl( aarg);
			;    } while ( -- counter > 0);
			;
			;
			;
			;#else  // SIZE
			;
			;    goto START;
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP:
			;        if ( Carry)
			;            goto SUBTRACT;
			;      START:
			;        W = aarg.low8 - arg2f24.low8;
			;        genSubW( aarg.high8, arg2f24.mid8);
			;        if (!Carry)
			;            goto SKIP_SUB;
			;       SUBTRACT:
			;        aarg.low8 -= arg2f24.low8;
			;        genSub( aarg.high8, arg2f24.mid8);
			;        Carry = 1;
			;       SKIP_SUB:
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        // Carry = 0;  // ok
			;        aarg = rl( aarg);
			;    } while ( -- counter > 0);
			;
			;#endif
			;
			;    if ( !arg1f24.15)  {
			;        if ( !arg1f24.high8)
			;            goto UNDERFLOW;
			;        arg1f24.high8 --;
			;        counter ++;
			;        goto LOOP;
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding)  {
			;        if ( Carry)
			;            goto ADD_1;
			;        aarg.low8 -= arg2f24.low8;
			;        genSub( aarg.high8, arg2f24.mid8);
			;        if (Carry)  {
			;          ADD_1:
			;            arg1f24.low8 += 1;
			;            if ( !arg1f24.low8)  {
			;                arg1f24.mid8 ++;
			;                if ( !arg1f24.mid8)  {
			;                    arg1f24.low16 = rr( arg1f24.low16);
			;                    arg1f24.high8 ++;
			;                    if ( !arg1f24.high8)
			;                        goto OVERFLOW;
			;                }
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
			;
			;  Div0:
			;    FpDiv0 = 1;
			;    goto SATURATE;
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
			;  RES0:
			;    arg1f24.high8 = 0;
			;    goto MANTISSA;
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;  SATURATE:
			;    arg1f24.high8 = 0xFF;
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
			;
			;  SET_SIGN:
			;    if ( !(sign & 0x80))
			;        arg1f24.15 = 0;
			;    return arg1f24;
			;}
			;
			;
			;float24 operator+ _fadd24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fadd24
			;    char xtra, temp;
			;    char expo = arg1f24.high8 - arg2f24.high8;
			;    if ( !Carry)  {
			;        expo = -expo;
			;        temp = arg1f24.high8;
			;        arg1f24.high8 = arg2f24.high8;
			;        arg2f24.high8 = temp;
			;        temp = arg1f24.mid8;
			;        arg1f24.mid8 = arg2f24.mid8;
			;        arg2f24.mid8 = temp;
			;        temp = arg1f24.low8;
			;        arg1f24.low8 = arg2f24.low8;
			;        arg2f24.low8 = temp;
			;    }
			;    if ( expo > sizeof(arg1f24)*8-7)
			;        goto RETURN;
			;    if ( !arg2f24.high8)
			;        goto RETURN;   // result is arg1f24
			;
			;    xtra = 0;
			;
			;    temp = arg1f24.mid8;
			;    char sign = arg2f24.mid8 ^ arg1f24.mid8;
			;    arg1f24.15 = 1;
			;    arg2f24.15 = 1;
			;
			;    while (1)  {
			;        W = 8;
			;        expo -= W;
			;        if ( !Carry)
			;            break;
			;        xtra = arg2f24.low8;
			;        arg2f24.low8 = arg2f24.mid8;
			;        arg2f24.mid8 = 0;
			;    }
			;    expo += W;
			;    if ( expo)  {
			;        do  {
			;            Carry = 0;
			;            arg2f24.low16 = rr( arg2f24.low16);
			;            xtra = rr( xtra);
			;        } while (--expo > 0);
			;    }
			;
			;
			;    if ( sign & 0x80)  {
			;        // SUBTRACT
			;        arg1f24.low8 -= arg2f24.low8;
			;        genSub( arg1f24.mid8, arg2f24.mid8);
			;        if (!Carry)  {  // arg2f24 > arg1f24
			;            arg1f24.low16 = -arg1f24.low16;
			;            // xtra == 0 because arg1f24.exp == arg2f24.exp
			;            temp ^= 0x80;  // invert sign
			;        }
			;        xtra = -xtra;
			;        if ( xtra)
			;            arg1f24.low16 --;
			;        // adjust result left
			;       #define counter expo
			;        counter = 3;
			;        while ( !arg1f24.mid8)  {
			;            arg1f24.mid8 = arg1f24.low8;
			;            arg1f24.low8 = xtra;
			;            xtra = 0;
			;            arg1f24.high8 -= 8;
			;            if ( !Carry)
			;                goto RES0;
			;            if ( --counter == 0)  // max 2 iterations
			;                goto RES0;
			;        }
			;       #undef counter
			;        while ( !arg1f24.15)  {
			;            Carry = 0;
			;            xtra = rl( xtra);
			;            arg1f24.low16 = rl( arg1f24.low16);
			;            arg1f24.high8 --;
			;            if ( !arg1f24.high8)
			;                goto RES0;   // UNDERFLOW?
			;        }
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding  &&  (xtra & 0x80))  {
			;            xtra = 0; // disable recursion
			;            goto INCREMENT;
			;        }
			;       #endif
			;    }
			;    else  {
			;        // ADD arg1f24 and arg2f24
			;        arg1f24.low8 += arg2f24.low8;
			;        genAdd( arg1f24.mid8, arg2f24.mid8);
			;        if ( Carry)  {
			;          ADJUST_RIGHT:
			;            arg1f24.low16 = rr( arg1f24.low16);
			;            xtra = rr( xtra);
			;            arg1f24.high8 += 1;  // exp
			;            if ( !arg1f24.high8)
			;                goto OVERFLOW;
			;        }
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding  &&  (xtra & 0x80))  {
			;          INCREMENT:
			;            arg1f24.low8 += 1;
			;            if ( !arg1f24.low8)  {
			;                arg1f24.mid8 += 1;
			;                if ( !arg1f24.mid8)  {
			;                    Carry = 1; // prepare for shift
			;                    arg1f24.0 = 0;  // disable recursion
			;                    goto ADJUST_RIGHT;
			;                }
			;            }
			;        }
			;       #endif
			;    }
			;    goto SET_SIGN;
			;
			;//  UNDERFLOW:
			;//    FpUnderFlow = 1;
			;  RES0:
			;    arg1f24.high8 = 0;
			;    goto MANTISSA;
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;    arg1f24.high8 = 0xFF;
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
			;
			;  SET_SIGN:
			;    if ( !(temp & 0x80))
			;        arg1f24.15 = 0;
			;
			;  RETURN:
			;    return arg1f24;
			;}
			;
			;
			;// SUBTRACTION
			;
			;float24 operator- _fsub24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fsub24
			;    arg2f24.mid8 ^= 0x80;
			;    arg1f24 += arg2f24;
			;    return arg1f24;
			;}
			;
			;
			;float24 operator=( int8 arg) @
			;float24 operator=( uns8 arg) @
			;float24 operator=( int16 arg) @
			;float24 operator=( uns16 arg) @
			;float24 operator= _int24ToFloat24( sharedM int24 arg1f24)
			;{
_int24ToFloat24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char expo = FpBIAS + 16 - 1;
			;    char sign = 0;
			;    if ( arg1f24 < 0)  {
			;        arg1f24 = -arg1f24;
			;        sign |= 0x80;
			;    }
			;    if ( arg1f24.high8)  {
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding && (arg1f24.low8 & 0x80))  {
			;            arg1f24.mid8 += 1;
			;            if ( !arg1f24.mid8)  {
			;                arg1f24.high8 += 1;
			;                if ( !arg1f24.high8)  {
			;                    Carry = 1;
			;                    arg1f24.high16 = rr( arg1f24.high16);
			;                    expo ++;
			;                }
			;            }
			;        }
			;       #endif
			;        expo += 8;
			;        arg1f24.low8 = arg1f24.mid8;
			;        arg1f24.mid8 = arg1f24.high8;
			;    }
			;    else if ( !arg1f24.midL8)  {
			;        expo -= 8;
			;        W = arg1f24.low8;
			;        if ( !W)
			;            goto RETURN;
			;        arg1f24.mid8 = W;
			;        arg1f24.low8 = 0;
			;    }
			;
			;    // arg1f24.mid8 != 0
			;    goto TEST_ARG1_B15;
			;    do  {
			;        Carry = 0;
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        expo --;
			;      TEST_ARG1_B15:
			;    } while ( !arg1f24.15);
			;
			;    arg1f24.high8 = expo;
			;    if ( !(sign & 0x80))
			;        arg1f24.15 = 0;
			;
			;  RETURN:
			;    float24 rval @ arg1f24;
			;    rval.low24 = arg1f24.low24;
			;    return rval;
			;}
			;
			;
			;float24 operator=( uns24 arg) @
			;float24 operator= _int32ToFloat24( int32 arg32)
			;{
_int32ToFloat24
			;    char expo = FpBIAS + 16 - 1;
			;    char sign = 0;
			;    if ( arg32 < 0)  {
			;        arg32 = -arg32;
			;        sign |= 0x80;
			;    }
			;    if ( arg32.high8)  {
			;        expo += 8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;        arg32.midH8 = arg32.high8;
			;    }
			;    if ( arg32.midH8)  {
			;       #ifndef DISABLE_ROUNDING
			;        if ( FpRounding && (arg32.low8 & 0x80))  {
			;            arg32.mid8 += 1;
			;            if ( !arg32.mid8)  {
			;                arg32.high8 += 1;
			;                if ( !arg32.high8)  {
			;                    Carry = 1;
			;                    arg32.high16 = rr( arg32.high16);
			;                    expo ++;
			;                }
			;            }
			;        }
			;       #endif
			;        expo += 8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;    }
			;    else if ( !arg32.midL8)  {
			;        expo -= 8;
			;        W = arg32.low8;
			;        if ( !W)
			;            goto RETURN;
			;        arg32.midL8 = W;
			;        arg32.low8 = 0;
			;    }
			;
			;    // arg32.mid8 != 0
			;    goto TEST_ARG_B15;
			;    do  {
			;        Carry = 0;
			;        arg32.low16 = rl( arg32.low16);
			;        expo --;
			;      TEST_ARG_B15:
			;    } while ( !arg32.15);
			;
			;    arg32.midH8 = expo;
			;    if ( !(sign & 0x80))
			;        arg32.15 = 0;
			;
			;  RETURN:
			;    float24 rval @ arg32;
			;    rval.low24 = arg32.low24;
			;    return rval;
			;}
			;
			;
			;uns8 operator=( sharedM float24 arg1f24) @
			;int8 operator=( sharedM float24 arg1f24) @
			;uns16 operator=( sharedM float24 arg1f24) @
			;int16 operator=( sharedM float24 arg1f24) @
			;int24 operator= _float24ToInt24( sharedM float24 arg1f24)
			;{
_float24ToInt24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char sign = arg1f24.mid8;
			;    char expo = arg1f24.high8 - FpBIAS;
			;    if ( !Carry)
			;        goto RES0;
			;    arg1f24.15 = 1;
			;
			;    arg1f24.high8 = 0;
			;   #ifndef DISABLE_ROUNDING
			;    char xtra = 0;
			;   #endif
			;
			;    // (a): expo = 0..7 : shift 1 byte to the right
			;    // (b): expo = 8..15: shift 0 byte
			;    // (c): expo = 16..23: shift 1 byte to the left
			;   #if __CoreSet__ / 100 == 12
			;    expo -= 16;
			;    expo = 0xFF - expo;  // COMF (Carry unchanged)
			;    if ( Carry)  {  // (c)
			;   #else
			;    expo = 15 - expo;
			;    if ( !Carry)  {  // (c)
			;   #endif
			;        expo += 8;
			;        if (!Carry)
			;            goto OVERFLOW;
			;        arg1f24.high8 = arg1f24.mid8;
			;        arg1f24.mid8 = arg1f24.low8;
			;        arg1f24.low8 = 0;
			;    }
			;    else  {  // (a) (b)
			;        // expo = 0 .. 15
			;        W = expo - 8;
			;        if ( Carry)  {  // (a)
			;            expo = W;
			;           #ifndef DISABLE_ROUNDING
			;            xtra = arg1f24.low8;
			;           #endif
			;            arg1f24.low8 = arg1f24.mid8;
			;            arg1f24.mid8 = 0;
			;        }
			;    }
			;    if ( expo)  {
			;        do  {
			;            Carry = 0;
			;            arg1f24.high8 = rr( arg1f24.high8);
			;            arg1f24.low16 = rr( arg1f24.low16);
			;           #ifndef DISABLE_ROUNDING
			;            xtra = rr( xtra);
			;           #endif
			;        } while ( --expo);
			;    }
			;    if (arg1f24.23)
			;        goto OVERFLOW;
			;   #ifndef DISABLE_ROUNDING
			;    if ( FpRounding && (xtra & 0x80))  {
			;        arg1f24.low8 += 1;
			;        if (!arg1f24.low8)  {
			;            arg1f24.mid8 += 1;
			;            if (!arg1f24.mid8)  {
			;                arg1f24.high8 += 1;
			;                if (arg1f24.23)
			;                    goto OVERFLOW;
			;            }
			;        }
			;    }
			;   #endif
			;    if ( sign & 0x80)
			;        arg1f24.low24 = -arg1f24.low24;
			;    goto RETURN;
			;
			;  RES0:
			;    W = 0;
			;    goto ASSIGNW;
			;  OVERFLOW:
			;    FpOverflow = 1;
			;    W = 0xFF;
			;  ASSIGNW:
			;    arg1f24.high8 = W;
			;    arg1f24.mid8 = W;
			;    arg1f24.low8 = W;
			;    arg1f24.23 = 0;
			;
			;  RETURN:
			;    int24 rval @ arg1f24;
			;    rval = arg1f24.low24;
			;    return rval;
			;}
			;
			;
			;bit operator< _f24_LT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LT_f24
			;    Carry = 0;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        goto RETURN;
			;    }
			;    if ( !arg2f24.15)
			;        goto RETURN;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;  RETURN:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;bit operator>= _f24_GE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GE_f24
			;    Carry = 1;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        return Carry;
			;    }
			;    Carry = 0;
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;    return Carry;
			;}
			;
			;
			;
			;bit operator> _f24_GT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GT_f24
			;    Carry = 0;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        if ( arg2f24.15)
			;            goto RETURN;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        goto RETURN;
			;    }
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;  RETURN:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;
			;bit operator<= _f24_LE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LE_f24
			;    Carry = 1;
			;    if ( !(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if ( !arg1f24.15)  {
			;        Carry = 0;
			;        if ( arg2f24.15)
			;            return Carry;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        return Carry;
			;    }
			;    if ( !arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;    return Carry;

  ; FILE C:\Global\Code\16F88\SCP1000\SCP1000-Testing.c
			;#include "c:\Global\Code\Pics\Code\stdio.c"   //Software based Basic Serial IO
			;
			;#include "c:\Global\Code\C\math24f.h"   //
			;
			;#define STATUS_LED PORTB.3
			;
			;#define GND  PORTA.0 //GND
			;#define PWR  PORTA.1 //3.3V
			;#define SCL  PORTA.2 //SCK This is clock input into SCP1000
			;#define SDI  PORTB.0 //MOSI This is input into the SCP1000 from the PIC
			;#define SDO  PORTA.3 //MISO This is output from SCP1000 into the PIC
			;#define CS   PORTA.4 //CSB This is chip select input - when low, the SCP1000 is selected
			;#define DRDY PORTB.7 //DRDY This is Data ready interrupt output from SCP1000
			;
			;
			;void boot_up(void);
			;
			;uns8 spi_comm(uns8 outgoing_byte);
			;uns8 read_register(uns8 register_name);
			;uns16 read_register16(uns8 register_name);
			;void write_register(uns8 register_name, uns8 register_value);
			;void SCP1000_Test(void);
			;
			;
			;void main(void)
			;{
main
			;
			;    uns8 choice;
			;    
			;    boot_up();
	BSF   0x03,RP0
	BCF   0x03,RP1
	CALL  boot_up
			;
			;    SCP1000_Test();
	CALL  SCP1000_Test
			;    
			;    while(1);
m047	GOTO  m047
			;
			;}//End Main
			;
			;void boot_up(void)
			;{
boot_up
			;    OSCCON = 0b.0111.0000; //Setup internal oscillator for 8MHz
	MOVLW .112
	MOVWF OSCCON
			;    while(OSCCON.2 == 0); //Wait for frequency to stabilize
m048	BTFSS OSCCON,2
	GOTO  m048
			;
			;    //Setup Ports
			;    ANSEL = 0b.0000.0000; //Turn off A/D
	CLRF  ANSEL
			;
			;    //Read RA3
			;    PORTA = 0b.0000.0010;
	MOVLW .2
	BCF   0x03,RP0
	MOVWF PORTA
			;    TRISA = 0b.0000.1000;  //0 = Output, 1 = Input
	MOVLW .8
	BSF   0x03,RP0
	MOVWF TRISA
			;
			;    //Input RB7 (DRDY), Output RB0
			;    PORTB = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTB
			;    TRISB = 0b.1000.0100;   //0 = Output, 1 = Input RX on RB2
	MOVLW .132
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;    //Setup the hardware UART module
			;    //=============================================================
			;    SPBRG = 51; //8MHz for 9600 inital communication baud rate
	MOVLW .51
	MOVWF SPBRG
			;    //SPBRG = 129; //20MHz for 9600 inital communication baud rate
			;
			;    TXSTA = 0b.0010.0100; //8-bit asych mode, high speed uart enabled
	MOVLW .36
	MOVWF TXSTA
			;    RCSTA = 0b.1001.0000; //Serial port enable, 8-bit asych continous receive mode
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;    //=============================================================
			;
			;    PWR = 1; //Power the unit with 3.3V
	BSF   PORTA,1
			;    GND = 0; 
	BCF   PORTA,0
			;    
			;    CS = 1; //Unselect SCP
	BSF   PORTA,4
			;    
			;}
	RETURN
			;
			;//Read data from SCP1000 via SPI
			;void SCP1000_Test(void)
			;{
SCP1000_Test
			;
			;    uns8 out_byte, in_byte, choice;
			;    uns16 big_in_byte;
			;
			;    PWR = 1; //Power the unit with 3.3V
	BSF   PORTA,1
			;    GND = 0; 
	BCF   PORTA,0
			;    
			;    CS = 1; //Unselect SCP
	BSF   PORTA,4
			;
			;    STATUS_LED = 0;
	BCF   PORTB,3
			;
			;    //Configure SCP1000 with low noise configuration
			;    //=====================================
			;    //write_register(place, thing)
			;    write_register(0x02, 0x2D);
	MOVLW .2
	MOVWF register_name_3
	MOVLW .45
	CALL  write_register
			;    write_register(0x01, 0x03);
	MOVLW .1
	MOVWF register_name_3
	MOVLW .3
	CALL  write_register
			;    write_register(0x03, 0x02);
	MOVLW .3
	MOVWF register_name_3
	MOVLW .2
	CALL  write_register
			;    
			;    delay_ms(100);
	MOVLW .100
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_ms
			;    //=====================================
			;
			;    while(1)
			;    {
			;        if(RCIF)
m049	BTFSS 0x0C,RCIF
	GOTO  m050
			;        {
			;            choice = RCREG;
	MOVF  RCREG,W
	MOVWF choice_2
			;            
			;            if(choice == 'x') break;
	XORLW .120
	BTFSC 0x03,Zero_
	GOTO  m052
			;        }
			;
			;        STATUS_LED = 1;
m050	BSF   PORTB,3
			;
			;        //Select High Resolution Mode
			;        write_register(0x03, 0x0A);
	MOVLW .3
	MOVWF register_name_3
	MOVLW .10
	CALL  write_register
			;        //Acquisistion starts
			;        while(DRDY == 0); //Wait for data ready pin to go high
m051	BTFSS PORTB,7
	GOTO  m051
			;
			;        STATUS_LED = 0;
	BCF   PORTB,3
			;        
			;        uns16 temp_data;
			;        temp_data = read_register16(0x21); //Read the temperature data
	MOVLW .33
	CALL  read_register16
	MOVWF temp_data
	MOVF  in_byte_3+1,W
	MOVWF temp_data+1
			;        temp_data /= 2; //This is (temp * 10) / 20 so that the answer of 27.9 comes out as 279 (easier to print)
	BCF   0x03,Carry
	RRF   temp_data+1,1
	RRF   temp_data,1
			;        printf("Temp=%d ", temp_data);
	CLRF  nate_2
	MOVF  temp_data,W
	MOVWF my_byte
	MOVF  temp_data+1,W
	MOVWF my_byte+1
	CALL  printf
			;    
			;        uns8 pressure_data_high;
			;        uns16 pressure_data_low;
			;    
			;        pressure_data_high = read_register(0x1F); //Read the pressure data MSB 3-bits
	MOVLW .31
	CALL  read_register
	MOVWF pressure_data_high
			;        pressure_data_high &= 0b.0000.0111; //Data bits are 2:0
	MOVLW .7
	ANDWF pressure_data_high,1
			;    
			;        pressure_data_low = read_register16(0x20); //Read the pressure data LSB 16-bits
	MOVLW .32
	CALL  read_register16
	MOVWF pressure_data_low
	MOVF  in_byte_3+1,W
	MOVWF pressure_data_low+1
			;        
			;        printf("Pressure[Pa]=%h-", pressure_data_high);
	MOVLW .9
	MOVWF nate_2
	MOVF  pressure_data_high,W
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;        printf("%h ", pressure_data_low);
	MOVLW .35
	MOVWF nate_2
	MOVF  pressure_data_low,W
	MOVWF my_byte
	MOVF  pressure_data_low+1,W
	MOVWF my_byte+1
	CALL  printf
			;            
			;        in_byte = read_register(0x01); //Read ASIC revision
	MOVLW .1
	CALL  read_register
	MOVWF in_byte
			;        printf("asic_rev=%h ", in_byte);
	MOVLW .26
	MOVWF nate_2
	MOVF  in_byte,W
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;    
			;        in_byte = read_register(0x07); //Read STATUS
	MOVLW .7
	CALL  read_register
	MOVWF in_byte
			;        printf("STATUS=%b\n", in_byte);
	MOVLW .39
	MOVWF nate_2
	MOVF  in_byte,W
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    }
	GOTO  m049
			;
			;}
m052	RETURN
			;
			;//Read 8-bit register
			;uns8 read_register(uns8 register_name)
			;{
read_register
	MOVWF register_name
			;    uns8 in_byte;
			;    
			;    register_name <<= 2;
	BCF   0x03,Carry
	RLF   register_name,1
	BCF   0x03,Carry
	RLF   register_name,1
			;    register_name &= 0b.1111.1100; //Read command
	MOVLW .252
	ANDWF register_name,1
			;
			;    CS = 0; //Select SPI Device
	BCF   PORTA,4
			;
			;    in_byte = spi_comm(register_name); //Write byte to device
	MOVF  register_name,W
	CALL  spi_comm
	MOVWF in_byte_2
			;    //in_byte is nothing, we need to clock in another 8 bits
			;    in_byte = spi_comm(0x00); //Send nothing, but we should get back the register value
	MOVLW .0
	CALL  spi_comm
	MOVWF in_byte_2
			;
			;    CS = 1;
	BSF   PORTA,4
			;    
			;    return(in_byte);
	RETURN
			;}
			;
			;//Read 16-bit register
			;uns16 read_register16(uns8 register_name)
			;{
read_register16
	MOVWF register_name_2
			;    uns16 in_byte;
			;    
			;    register_name <<= 2;
	BCF   0x03,Carry
	RLF   register_name_2,1
	BCF   0x03,Carry
	RLF   register_name_2,1
			;    register_name &= 0b.1111.1100; //Read command
	MOVLW .252
	ANDWF register_name_2,1
			;
			;    CS = 0; //Select SPI Device
	BCF   PORTA,4
			;
			;    in_byte.high8 = spi_comm(register_name); //Write byte to device
	MOVF  register_name_2,W
	CALL  spi_comm
	MOVWF in_byte_3+1
			;    //in_byte is nothing, we need to clock in another 8 bits
			;    in_byte.high8 = spi_comm(0x00); //Send nothing, but we should get back the register value
	MOVLW .0
	CALL  spi_comm
	MOVWF in_byte_3+1
			;    in_byte.low8 = spi_comm(0x00); //Send nothing, but we should get back the register value
	MOVLW .0
	CALL  spi_comm
	MOVWF in_byte_3
			;
			;    CS = 1;
	BSF   PORTA,4
			;    
			;    return(in_byte);
	RETURN
			;}
			;
			;//Sends a write command to SCP1000
			;void write_register(uns8 register_name, uns8 register_value)
			;{
write_register
	MOVWF register_value
			;    uns8 in_byte;
			;    
			;    register_name <<= 2;
	BCF   0x03,Carry
	RLF   register_name_3,1
	BCF   0x03,Carry
	RLF   register_name_3,1
			;    register_name |= 0b.0000.0010; //Write command
	BSF   register_name_3,1
			;
			;    CS = 0; //Select SPI device
	BCF   PORTA,4
			;
			;    in_byte = spi_comm(register_name); //Send register location
	MOVF  register_name_3,W
	CALL  spi_comm
	MOVWF in_byte_4
			;    in_byte = spi_comm(register_value); //Send value to record into register
	MOVF  register_value,W
	CALL  spi_comm
	MOVWF in_byte_4
			;    
			;    CS = 1;
	BSF   PORTA,4
			;    
			;    //Return nothing
			;}
	RETURN
			;
			;//Basic SPI send and receive
			;uns8 spi_comm(uns8 outgoing_byte)
			;{
spi_comm
	MOVWF outgoing_byte
			;    uns8 incoming_byte, x;
			;
			;    for(x = 0 ; x < 8 ; x++)
	CLRF  x_5
m053	MOVLW .8
	SUBWF x_5,W
	BTFSC 0x03,Carry
	GOTO  m054
			;    {
			;        SCL = 0; //Toggle the SPI clock
	BCF   PORTA,2
			;
			;        SDI = outgoing_byte.7; //Put bit on SPI data bus
	BTFSS outgoing_byte,7
	BCF   PORTB,0
	BTFSC outgoing_byte,7
	BSF   PORTB,0
			;        outgoing_byte <<= 1; //Rotate byte 1 to the left
	BCF   0x03,Carry
	RLF   outgoing_byte,1
			;
			;        SCL = 1;
	BSF   PORTA,2
			;
			;        incoming_byte <<= 1; //Rotate byte 1 to the left
	BCF   0x03,Carry
	RLF   incoming_byte,1
			;        incoming_byte.0 = SDO; //Read bit on SPI data bus
	BCF   incoming_byte,0
	BTFSC PORTA,3
	BSF   incoming_byte,0
			;    }
	INCF  x_5,1
	GOTO  m053
			;    
			;    return(incoming_byte);
m054	MOVF  incoming_byte,W
	RETURN

	END


; *** KEY INFO ***

; 0x0055 P0    9 word(s)  0 % : delay_us
; 0x005E P0   24 word(s)  1 % : delay_ms
; 0x0076 P0   26 word(s)  1 % : delay_s_lp
; 0x0090 P0   16 word(s)  0 % : enable_uart_TX
; 0x00A0 P0   19 word(s)  0 % : enable_uart_RX
; 0x00B3 P0    6 word(s)  0 % : putc
; 0x00B9 P0    6 word(s)  0 % : getc
; 0x00BF P0   21 word(s)  1 % : scanc
; 0x00D4 P0   20 word(s)  0 % : bin2Hex
; 0x00E8 P0  215 word(s) 10 % : printf
; 0x0004 P0   56 word(s)  2 % : _const1
; 0x01C4 P0   27 word(s)  1 % : boot_up
; 0x026D P0   23 word(s)  1 % : spi_comm
; 0x023B P0   16 word(s)  0 % : read_register
; 0x024B P0   19 word(s)  0 % : read_register16
; 0x025E P0   15 word(s)  0 % : write_register
; 0x01DF P0   92 word(s)  4 % : SCP1000_Test
; 0x01BF P0    5 word(s)  0 % : main

; RAM usage: 33 bytes (32 local), 335 bytes free
; Maximum call level: 3
;  Codepage 0 has  641 word(s) :  31 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 616 code words (15 %)
